class Diagr
{

  int w, h, crosshair, alavanca, z, j, sum, internal;
  float a1x, a1y, a2x, a2y, a3x, a3y, a4x, a4y, c1x, c1y, c2x, c2y, c3x, c3y, c4x, c4y;
  float X0, X1, X2, Y, YY, xt1, xt2;
  float lx1, lx2, ly1, ly2, Lx1, Ly1, Lx2, Ly2;
  float compR, compRS, propR, propRS;
  float vx1, vx2, vy1, vy2, Vx1, Vy1, Vx2, Vy2; 
  float startTime;
  boolean mouseHold, extract, bifase, blink, calc;
  color cor1, cor2, cor3, corExt, cor1b, cor2b;
  char letra;

  Diagr (int _w, int _h)
  {
    w=_w;
    h=_h;
    Y=0;
    YY=0;
    crosshair=7;
    alavanca=0;
    bifase=false;
    blink=false;
    cor1 = color(140,30,215);
    cor1b = color(255,150);//color(205,70,205);
    cor2 = color(20,150,10);
    cor2b = color(255,150);//color(140,210,125);
    cor3 = color(240,160,0);

    vy1=Vy1=diagrOffY+h;    // constants won't change
    vx1=vx2=670;
    Vx1=Vx2=730;

    X0=-10; // putaria, dar um jeito nisso!
    
    calc=false;
  }

  void setPoints(float _a1x, float _a1y, float _c1x, float _c1y, float _c2x, float _c2y, float _a2x, float _a2y,
  float _a3x, float _a3y, float _c3x, float _c3y, float _c4x, float _c4y, float _a4x, float _a4y)
  {
    a1x=_a1x;
    a2x=_a2x;
    a3x=_a3x;
    a4x=_a4x;
    a1y=_a1y;
    a2y=_a2y;
    a3y=_a3y;
    a4y=_a4y;
    c1x=_c1x;
    c2x=_c2x;
    c3x=_c3x;
    c4x=_c4x;
    c1y=_c1y;
    c2y=_c2y;
    c3y=_c3y;
    c4y=_c4y;
  }

  void setPoint (char c, int n, float valx, float valy)
  {
    if (c=='a')
    {
      if (n==1) { 
        a1x=valx; 
        a1y=valy;
      }
      if (n==2) { 
        a2x=valx; 
        a2y=valy;
      }
      if (n==3) { 
        a3x=valx; 
        a3y=valy;
      }
      if (n==4) { 
        a4x=valx; 
        a4y=valy;
      }
    }
    else if (c=='c')
    {
      if (n==1) { 
        c1x=valx; 
        c1y=valy;
      }
      if (n==2) { 
        c2x=valx; 
        c2y=valy;
      }
      if (n==3) { 
        c3x=valx; 
        c3y=valy;
      }
      if (n==4) { 
        c4x=valx; 
        c4y=valy;
      }
    }
  }
  
  void showPts(int tipo)
  {
    pushStyle();
    strokeWeight(1);
    stroke(0);
    switch (tipo)
    {
      case 1:
      line (a1x, a1y, c1x, c1y);
      line (a2x, a2y, c2x, c2y);
      fill (127,200,250,150);
      ellipse (c1x, c1y, 20,20);
      fill (127,250,200,150);
      ellipse (c2x, c2y, 20,20);
      break;
      
      case 2:
      line (a3x, a3y, c3x, c3y);
      line (a4x, a4y, c4x, c4y);
      fill (127,200,250,150);
      ellipse (c3x, c3y, 20,20);
      fill (127,250,200,150);
      ellipse (c4x, c4y, 20,20);
      break;
    }
    image (mouse, 500,410,80,80);
    popStyle();
  }
      

  // ======================================================== DRAW ======================================================== 
  void draw()
  {

    translate(diagrOffX, diagrOffY);
    fill(0,1);
    stroke(0);

    // curve
    bezier (a1x, a1y, c1x, c1y, c2x, c2y, a2x, a2y);
    bezier (a3x, a3y, c3x, c3y, c4x, c4y, a4x, a4y);
    //bezier (0,diagrH-50, c1x, c1y, c2x, c2y,diagrW,50);
    //bezier (0,diagrH-50, c3x, c3y, c4x, c4y,diagrW,50);  delete

    //gridlines
    stroke(120,100);
    strokeWeight(1);
    for (int i=0; i<=100; i+=20)
    {
      textFont (verd, 14);
      textAlign(CENTER);
      fill(0);
      text (i, i/100.*w, h+17);
      line(0, i*h/100., w, i*h/100.);
      line(i/100.*w, 0, i/100.*w, h);
      fill (0,1);
    }
    
    // control Points
    if (keyHold)
    {
      if (key == CODED) {
        if (keyCode == SHIFT)
        {
          Nicu.showPts(1);
          upperCurve=true;
        }
        if (keyCode == CONTROL)
        {
          Nicu.showPts(2);
          downerCurve=true;        
        }
      }
    }

    if (mouseHold)      // atualiza a posição atual do mouse enquanto estiver clicado
    {
      Y=mouseY-diagrOffY;
      X0=mouseX-diagrOffX;
      calcX (Y);        // itera as fronteiras da linha de amarração
    }

    if (X0>=X1 && X0<=X2)
    {
      bifase=true;
      stroke (180);
      strokeWeight(2);
      line (X1, Y, X2, Y);    // linha de amarração enquanto pressionada

      pushStyle();
      strokeWeight(1);        
      stroke (255,0,0);
      line (X0, Y, X0, diagrH);  // linha de cota do crosshair
      fill (255,0,0);
      text (round(X0/w*100)/10, X0-6, h-5);
      text (round(X0/w*100)%10, X0+6, h-5);
      popStyle();

      prolong();
      //stroke (255,0,0);
    }
    else
    {
      bifase=false;
      stroke (0);
    }

    if (extract) extract();
    if (calc) calc();
    
    //crosshair
    strokeWeight(1);
    stroke (255,0,0);
    line(X0-crosshair, Y, X0+crosshair, Y);
    line(X0, Y-crosshair, X0, Y+crosshair);

    // borders
    stroke(0);
    strokeWeight(2);
    rect (0,0,diagrW,diagrH);

    fill(0,1);
  }

  void prolong ()
  {
    pushStyle();
    float speed=5;

    if (prolong && !prol_trig)
    {

      prol_trig = true;
    }   

    if (prolong)
    {
      stroke (0);
      strokeWeight(2);
      line (X1, Y, X2, Y);

      stroke(50,50,255);      
      // prolongs vertical
      line (X1, Y, X1, YY);
      line (X2, Y, X2, YY);

      // enhancement horizontal

      stroke (cor1);
      line (X0, Y, xt1, Y);
      stroke (cor2);
      line (X0, Y, xt2, Y);

      if (xt1>X1) xt1+=(X1-xt1-10)*0.1;
      else {
        xt1=X1;
        sum++;
      }
      if (xt2<X2) xt2+=(X2-xt2+10)*0.1;
      else {
        xt2=X2;
        sum++;
      }


      if (YY<diagrH) YY+=(diagrH-YY+15)*0.1;
      else
      {
        YY=diagrH;
        fill(0,0,255);
        text (round(X1/w*100), X1+1, h+30);
        text (round(X2/w*100), X2+1, h+30);
        prol_trig=false;
        sum++;
        fill(0,1);
        //if (!extract) noLoop();
      }
    }
    popStyle();
  }


  //  ======================================================== EXTRACT ========================================================

  void extract ()
  {

    if (!prol_trig)            // comanda o basico para tomar conta depois do prolong()
    {
      if (z>1) {
        if (frameCount%15==0)    // make selected blink; influencia la em cima antes do switch
          blink^=true;
      }

      pushStyle();
      // herdado do prolong
      strokeWeight(3);
      if (alavanca==1 && blink) stroke (cor1b); 
      else stroke (cor1);
      line (X0, Y, X1, Y);
      if (alavanca==2 && blink) stroke (cor2b); 
      else stroke (cor2);
      line (X0, Y, X2, Y);

      // prolongs vertical
      stroke(50,50,255);
      line (X1, Y, X1, YY);
      line (X2, Y, X2, YY);
      fill(0,0,255);
      text (round(X1/w*100), X1+1, h+30);
      text (round(X2/w*100), X2+1, h+30);
      popStyle();
    }


    pushStyle();
    if (!prol_trig)            // comanda todo o switch pra depois de finalizar o prolong()
      switch (z) //etapas
      {
      case 1:                      // coisas que runam uma vez só //  RUNONCE
        ly1=ly2=Ly1=Ly2=Y;
        if (alavanca==1)
        { 
          lx1=X0;
          lx2=X2;
          Lx1=X1;
          Lx2=X2;
          corExt = cor2;
          letra = 'S';
        }
        else if (alavanca==2)
        { 
          lx1=X1;  
          lx2=X0; 
          Lx1=X1; 
          Lx2=X2;
          corExt = cor1;
          letra = 'R';
        }

        // calcula proporções
        compR  = abs(lx1-lx2);
        compRS = abs(Lx1-Lx2);
        propR  = abs(lx1-lx2)*100./w;
        propRS = abs(Lx1-Lx2)*100./w;

        // inicia barras verticais
        vy2=vy1;
        Vy2=Vy1;

        // zera contador de etapas internas
        internal=0;

        strokeWeight(2);
        stroke (cor3);
        line (Lx1, Ly1, Lx2, Ly2);
        stroke (corExt);
        line (lx1, ly1, lx2, ly2);
        if (!prol_trig) {
          z=2;
          j=0;
        }
        loop();
        break;

      case 2:

        if (j<30)
        {
          ly1-= 0.1*(ly1-Y+30); 
          ly2-=0.1*(ly2-Y+30); 
          Ly1+=0.1*(ly2-Y+30); 
          Ly2+=0.1*(ly2-Y+30);
        }
        j+=1;

        strokeWeight(3);
        stroke (cor3);
        line (Lx1, Ly1, Lx2, Ly2);
        stroke (corExt);
        line (lx1, ly1, lx2, ly2);

        if (j>=30 && !prol_trig) {
          z=3;
          startTime=millis();
        }
        break;


      case 3:
        if (millis()-startTime>500)
          z=4;

        pushStyle();
        if (alavanca==1) fill(cor2);                    // define que cor vai subir pra mostrar o numero
        else if (alavanca==2) fill(cor1);
        //textFont  (arialb, 16);
        //text (nf(propR, 2, 1), (lx1+lx2)/2, Y-34);    // formata e mostra o numero
        text (letra, (lx1+lx2)/2, Y-34);
        fill(cor3);
        //text (nf(propRS, 2, 1), (Lx1+Lx2)/2, Y+40); !!! revitalizar
        text ("R+S", (Lx1+Lx2)/2, Y+40);
        popStyle();

        strokeWeight(3);
        stroke (cor3);
        line (Lx1, Ly1, Lx2, Ly2);
        stroke (corExt);
        line (lx1, ly1, lx2, ly2);
        break;

      case 4:
        pushStyle();
        if (abs(vy1-vy2-compR)>=EPS)
        {
          vy2 += ((vy1-compR)-vy2)*0.1;
        }
        else 
        {
          vy2 = vy1-compR;
          internal++;
        }

        if (abs(Vy1-Vy2-compRS)>=EPS)
        {
          Vy2 += ((Vy1-compRS)-Vy2)*0.1;
        }
        else 
        {
          Vy2=Vy1-compRS;
          internal++;
        }
        
        if (internal>1)
             z=5;
        else internal=0;
        popStyle();
        
        case 5:
        if (z==5) calc=true;
        
        pushStyle();

        strokeWeight(3);
        stroke (corExt);
        line (lx1, ly1, lx2, ly2);
        stroke (cor3);
        line (Lx1, Ly1, Lx2, Ly2);

        strokeWeight(15);
        stroke (corExt);
        line (vx1, vy1, vx2, vy2);
        stroke (cor3);
        line (Vx1, Vy1, Vx2, Vy2);
        
        println((vy1-vy2)/compR);

        fill (corExt);
        text (nf((vy1-vy2)/compR*propR,2,2), vx1, vy2-20);
        fill (cor3);
        text (nf((Vy1-Vy2)/compRS*propRS,2,2), Vx1, Vy2-20);
        
        if (alavanca==1) fill(cor2);                    // define que cor vai subir pra mostrar o numero
        else if (alavanca==2) fill(cor1);
        //textFont  (arialb, 16);
        //text (nf(propR, 2, 1), (lx1+lx2)/2, Y-34);    // formata e mostra o numero
        text (letra, (lx1+lx2)/2, Y-34);
        fill(cor3);
        //text (nf(propRS, 2, 1), (Lx1+Lx2)/2, Y+40); !!! revitalizar
        text ("R+S", (Lx1+Lx2)/2, Y+40);

        popStyle();
        break;
      }

    popStyle();
    //noLoop();
  }


void calc()
{
  pushStyle();
  textFont (verdG, 18);
  fill (0);
  text ("W= ",640,40);
  text (letra ,700,25);
  text ("R+S" ,700,55);
  stroke(0);
  strokeWeight(2);
  line (665,33,735,33);
  
  text ("W= ",640,100);
  text (nf(propR,2,2) ,700,85);
  text (nf(propRS,2,2) ,700,115);
  stroke(0);
  strokeWeight(2);
  line (665,93,735,93);
  
  text ("W= ",640,160);
  text (nf(propR/propRS*100.,2,1)+"%" ,700,160);

  popStyle();
  
}
  



  void calcX (float Y)        // metodo iterativo calcula as intersecções com as fronteiras baseando-se no Y atual
  { 
    float p;
    float resolution=0.001;
    float test=-10;

    for (p=0; sq(test-Y)>EPS && p<=1; p+=resolution) {
      test =  bezierPoint (a1y, c1y, c2y, a2y, p);  // bezierY
    }
    X1 =    bezierPoint (a1x, c1x, c2x, a2x, p);         // bezierX

    test=-10;
    for (p=0; sq(test-Y)>EPS && p<=1; p+=resolution) {
      test =  bezierPoint (a3y, c3y, c4y, a4y, p);  // bezierY
    }
    X2 =    bezierPoint (a3x, c3x, c4x, a4x, p);         // bezierX
  }

  float calcX (int n, float Y1)  // metodo iterativo retorna uma intersecção específica para uma das fronteiras
  { 
    float p, ans=0;
    float resolution=0.0001;
    float test=-10;

    if (n==1)
    {
      for (p=0; sq(test-Y)>EPS && p<=1; p+=resolution) {
        test =  bezierPoint (a1y, c1y, c2y, a2y, p);  // bezierY
      }
      ans =    bezierPoint (a1x, c1x, c2x, a2x, p);         // bezierX
    } 
    test=-10;
    if (n==2)
    {
      for (p=0; sq(test-Y)>EPS && p<=1; p+=resolution) {
        test =  bezierPoint (a3y, c3y, c4y, a4y, p);  // bezierY
      }
      ans =    bezierPoint (a3x, c3x, c4x, a4x, p);         // bezierX
    }
    return ans;
  }




  void mousePressed ()
  {
    if (mouseButton==LEFT)
    {
      mousebt=1;
      mouseHold=true;

      prolong=false;    //cancela tudo e coloca no modo hold
      prol_trig=false;
      extract=false;
      z=1;              // zera o extract
      loop();
    }
    if (mouseButton==RIGHT)
    {
      if (bifase)
      {
        if (mouseX-diagrOffX<X0)
          alavanca=1;
        else if (mouseX-diagrOffX>X0)
          alavanca=2;
        //println (alavanca);
        else alavanca=0;
        if (alavanca!=0) {
          extract=true;        // inicia o extract
          z=1;
        }
        loop();
      }
    }
  }

  void mouseReleased ()
  {
    if (mousebt==1)
    {
      mouseHold=false;
      prolong=true;
      YY=Y;
      xt1=xt2=X0;
      prol_trig=true;
    }
    mousebt=0;
  }

  void keyPressed ()
  {
    if (!keyHold)
    {
      keyHold=true;
    }
  }
  
  void keyReleased()
  {
    keyHold=false;
  }

/* case needed
float getPoint (char c, int n, char comp)
  {
    if (c=='a')
    {
      if (n==1) { 
        if (comp=='x') return a1x; 
        if (comp=='y') return a1y;
      }
      if (n==2) { 
        if (comp=='x') return a2x; 
        if (comp=='y') return a2y;
      }
      if (n==3) { 
        if (comp=='x') return a3x; 
        if (comp=='y') return a3y;
      }
      if (n==4) { 
        if (comp=='x') return a4x; 
        if (comp=='y') return a4y;
      }
    }
    else if (c=='c')
    {
      if (n==1) { 
        if (comp=='x') return c1x; 
        if (comp=='y') return c1y;
      }
      if (n==2) { 
        if (comp=='x') return c2x; 
        if (comp=='y') return c2y;
      }
      if (n==3) { 
        if (comp=='x') return c3x; 
        if (comp=='y') return c3y;
      }
      if (n==4) { 
        if (comp=='x') return c4x; 
        if (comp=='y') return c4y;
      }
    }
    return -1;
  }
  */
  
}



